import { shopAction } from '../action';

export const defaultState = {
  userCash: 12,
  cash: 0,
  bar: {
    quantity: 3,
    price: 5,
  },
  cake: {
    quantity: 5,
    price: 2,
  },
  sandwich: {
    quantity: 8,
    price: 6,
  },
  toast: {
    quantity: 11,
    price: 8,
  },
};

export function shopReducer(state = defaultState, { type, payload }) {
  switch (type) {
    case shopAction.cash:
      state[type] = payload;
      return state;
    case shopAction.userCash:
      state[type] = payload;
      return state;
    case shopAction[type]:
      if (state[type].quantity - payload < 0 || payload <= 0) return state;
      const sold = state[type].price * payload;
      if (sold <= state.userCash) {
        state[type].quantity = state[type].quantity - payload;
        state.cash += sold;
        state.userCash -= sold;
      }
      return state;
    default:
      return state;
  }
}
